<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: src/Bonus.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Bonus.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="Bonus_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef Bonus_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define Bonus_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="GameObject_8h.html">GameObject.h</a>&quot;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">class </span><a class="code" href="classCollisionVisitor.html">CollisionVisitor</a>;</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">class </span><a class="code" href="classPlayer.html">Player</a>;</div>
<div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="classBonus.html">   12</a></span>&#160;<span class="keyword">class </span><a class="code" href="classBonus.html">Bonus</a>: <span class="keyword">public</span> <a class="code" href="classGameObject.html">GameObject</a>{</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <a class="code" href="classBonus.html#a5270da1a7774a1269d602b86539070a0">Bonus</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; x, <span class="keyword">const</span> <span class="keywordtype">int</span> &amp; y);</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classBonus.html#a640d3edcd92fa6d886cdeca9f6130928">Visit</a> (<a class="code" href="classCollisionVisitor.html">CollisionVisitor</a> * visitor) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classBonus.html#a5b431fadd9abfe4bf59f9879f70a3410">CollideWith</a> (<a class="code" href="classGameObject.html">GameObject</a> * collisionObject) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classBonus.html#af6165bb5b501cf8d64a7fd8d521ba29e">ApplyBonus</a>(<a class="code" href="classPlayer.html">Player</a> * player)=0;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classBonus.html#a5659c52191612eaeb9b0dcaab6d5bb09">Update</a>() <span class="keyword">override</span>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;};</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classRocketBonus.html">   42</a></span>&#160;<span class="keyword">class </span><a class="code" href="classRocketBonus.html">RocketBonus</a> : <span class="keyword">public</span> <a class="code" href="classBonus.html">Bonus</a>{</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <a class="code" href="classRocketBonus.html#aa7e42757231299fa8963fe3df5c0b84b">RocketBonus</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; x, <span class="keyword">const</span> <span class="keywordtype">int</span> &amp; y);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classRocketBonus.html#a91815f3ea62241e18bf8e79f1450c92d">ApplyBonus</a>(<a class="code" href="classPlayer.html">Player</a> * player)<span class="keyword">override</span>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;};</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="classCannonBonus.html">   52</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCannonBonus.html">CannonBonus</a> : <span class="keyword">public</span> <a class="code" href="classBonus.html">Bonus</a>{</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <a class="code" href="classCannonBonus.html#a55e6538af4050bb83b09fbab575e1a6d">CannonBonus</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; x, <span class="keyword">const</span> <span class="keywordtype">int</span> &amp; y);</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCannonBonus.html#ade644ed76cdf178c8a7c48e337213049">ApplyBonus</a>(<a class="code" href="classPlayer.html">Player</a> * player)<span class="keyword">override</span>;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;};</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="classMachineGunBonus.html">   62</a></span>&#160;<span class="keyword">class </span><a class="code" href="classMachineGunBonus.html">MachineGunBonus</a> : <span class="keyword">public</span> <a class="code" href="classBonus.html">Bonus</a>{</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <a class="code" href="classMachineGunBonus.html#a18f488b1092ee0899f3bd06109b676ea">MachineGunBonus</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; x, <span class="keyword">const</span> <span class="keywordtype">int</span> &amp; y);</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMachineGunBonus.html#a6c1ea93285d160a3422619b09c162d3f">ApplyBonus</a>(<a class="code" href="classPlayer.html">Player</a> * player)<span class="keyword">override</span>;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;};</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="classHealBonus.html">   72</a></span>&#160;<span class="keyword">class </span><a class="code" href="classHealBonus.html">HealBonus</a> : <span class="keyword">public</span> <a class="code" href="classBonus.html">Bonus</a>{</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <a class="code" href="classHealBonus.html#a39746528bab725cfbc3f286da30e8e74">HealBonus</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; x, <span class="keyword">const</span> <span class="keywordtype">int</span> &amp; y);</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classHealBonus.html#a8243a9cd0a995afe559cced074b82836">ApplyBonus</a>(<a class="code" href="classPlayer.html">Player</a> * player)<span class="keyword">override</span>;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;};</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* Bonus_H */</span><span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassGameObject_html"><div class="ttname"><a href="classGameObject.html">GameObject</a></div><div class="ttdoc">Abstract class that represents GameObject with collision and movement properties.</div><div class="ttdef"><b>Definition:</b> GameObject.h:14</div></div>
<div class="ttc" id="aclassMachineGunBonus_html"><div class="ttname"><a href="classMachineGunBonus.html">MachineGunBonus</a></div><div class="ttdoc">MachineGun weapon bonus.</div><div class="ttdef"><b>Definition:</b> Bonus.h:62</div></div>
<div class="ttc" id="aclassRocketBonus_html"><div class="ttname"><a href="classRocketBonus.html">RocketBonus</a></div><div class="ttdoc">RocketLauncher weapon bonus.</div><div class="ttdef"><b>Definition:</b> Bonus.h:42</div></div>
<div class="ttc" id="aclassRocketBonus_html_aa7e42757231299fa8963fe3df5c0b84b"><div class="ttname"><a href="classRocketBonus.html#aa7e42757231299fa8963fe3df5c0b84b">RocketBonus::RocketBonus</a></div><div class="ttdeci">RocketBonus(const int &amp;x, const int &amp;y)</div><div class="ttdef"><b>Definition:</b> Bonus.cpp:24</div></div>
<div class="ttc" id="aclassBonus_html_a5270da1a7774a1269d602b86539070a0"><div class="ttname"><a href="classBonus.html#a5270da1a7774a1269d602b86539070a0">Bonus::Bonus</a></div><div class="ttdeci">Bonus(const int &amp;x, const int &amp;y)</div><div class="ttdoc">Construct a new Bonus object for given coordinates.</div><div class="ttdef"><b>Definition:</b> Bonus.cpp:6</div></div>
<div class="ttc" id="aclassHealBonus_html"><div class="ttname"><a href="classHealBonus.html">HealBonus</a></div><div class="ttdoc">Health repairing bonus.</div><div class="ttdef"><b>Definition:</b> Bonus.h:72</div></div>
<div class="ttc" id="aclassBonus_html"><div class="ttname"><a href="classBonus.html">Bonus</a></div><div class="ttdoc">Abstract class representing bonuses that can be applied to Player.</div><div class="ttdef"><b>Definition:</b> Bonus.h:12</div></div>
<div class="ttc" id="aclassMachineGunBonus_html_a18f488b1092ee0899f3bd06109b676ea"><div class="ttname"><a href="classMachineGunBonus.html#a18f488b1092ee0899f3bd06109b676ea">MachineGunBonus::MachineGunBonus</a></div><div class="ttdeci">MachineGunBonus(const int &amp;x, const int &amp;y)</div><div class="ttdef"><b>Definition:</b> Bonus.cpp:40</div></div>
<div class="ttc" id="aclassRocketBonus_html_a91815f3ea62241e18bf8e79f1450c92d"><div class="ttname"><a href="classRocketBonus.html#a91815f3ea62241e18bf8e79f1450c92d">RocketBonus::ApplyBonus</a></div><div class="ttdeci">void ApplyBonus(Player *player) override</div><div class="ttdoc">Pure virtual function to apply bonus modifier to player.</div><div class="ttdef"><b>Definition:</b> Bonus.cpp:28</div></div>
<div class="ttc" id="aclassHealBonus_html_a39746528bab725cfbc3f286da30e8e74"><div class="ttname"><a href="classHealBonus.html#a39746528bab725cfbc3f286da30e8e74">HealBonus::HealBonus</a></div><div class="ttdeci">HealBonus(const int &amp;x, const int &amp;y)</div><div class="ttdef"><b>Definition:</b> Bonus.cpp:47</div></div>
<div class="ttc" id="aclassCannonBonus_html_ade644ed76cdf178c8a7c48e337213049"><div class="ttname"><a href="classCannonBonus.html#ade644ed76cdf178c8a7c48e337213049">CannonBonus::ApplyBonus</a></div><div class="ttdeci">void ApplyBonus(Player *player) override</div><div class="ttdoc">Pure virtual function to apply bonus modifier to player.</div><div class="ttdef"><b>Definition:</b> Bonus.cpp:36</div></div>
<div class="ttc" id="aclassHealBonus_html_a8243a9cd0a995afe559cced074b82836"><div class="ttname"><a href="classHealBonus.html#a8243a9cd0a995afe559cced074b82836">HealBonus::ApplyBonus</a></div><div class="ttdeci">void ApplyBonus(Player *player) override</div><div class="ttdoc">Pure virtual function to apply bonus modifier to player.</div><div class="ttdef"><b>Definition:</b> Bonus.cpp:50</div></div>
<div class="ttc" id="aclassCannonBonus_html_a55e6538af4050bb83b09fbab575e1a6d"><div class="ttname"><a href="classCannonBonus.html#a55e6538af4050bb83b09fbab575e1a6d">CannonBonus::CannonBonus</a></div><div class="ttdeci">CannonBonus(const int &amp;x, const int &amp;y)</div><div class="ttdef"><b>Definition:</b> Bonus.cpp:32</div></div>
<div class="ttc" id="aclassBonus_html_a640d3edcd92fa6d886cdeca9f6130928"><div class="ttname"><a href="classBonus.html#a640d3edcd92fa6d886cdeca9f6130928">Bonus::Visit</a></div><div class="ttdeci">void Visit(CollisionVisitor *visitor) override</div><div class="ttdoc">Pure virtual function for accepting visitor.</div><div class="ttdef"><b>Definition:</b> Bonus.cpp:16</div></div>
<div class="ttc" id="aclassPlayer_html"><div class="ttname"><a href="classPlayer.html">Player</a></div><div class="ttdoc">Represent player, takes user input.</div><div class="ttdef"><b>Definition:</b> Player.h:14</div></div>
<div class="ttc" id="aclassMachineGunBonus_html_a6c1ea93285d160a3422619b09c162d3f"><div class="ttname"><a href="classMachineGunBonus.html#a6c1ea93285d160a3422619b09c162d3f">MachineGunBonus::ApplyBonus</a></div><div class="ttdeci">void ApplyBonus(Player *player) override</div><div class="ttdoc">Pure virtual function to apply bonus modifier to player.</div><div class="ttdef"><b>Definition:</b> Bonus.cpp:44</div></div>
<div class="ttc" id="aclassCannonBonus_html"><div class="ttname"><a href="classCannonBonus.html">CannonBonus</a></div><div class="ttdoc">Cannon weapon bonus.</div><div class="ttdef"><b>Definition:</b> Bonus.h:52</div></div>
<div class="ttc" id="aclassBonus_html_af6165bb5b501cf8d64a7fd8d521ba29e"><div class="ttname"><a href="classBonus.html#af6165bb5b501cf8d64a7fd8d521ba29e">Bonus::ApplyBonus</a></div><div class="ttdeci">virtual void ApplyBonus(Player *player)=0</div><div class="ttdoc">Pure virtual function to apply bonus modifier to player.</div></div>
<div class="ttc" id="aGameObject_8h_html"><div class="ttname"><a href="GameObject_8h.html">GameObject.h</a></div></div>
<div class="ttc" id="aclassBonus_html_a5659c52191612eaeb9b0dcaab6d5bb09"><div class="ttname"><a href="classBonus.html#a5659c52191612eaeb9b0dcaab6d5bb09">Bonus::Update</a></div><div class="ttdeci">void Update() override</div><div class="ttdoc">Update to move object.</div><div class="ttdef"><b>Definition:</b> Bonus.cpp:13</div></div>
<div class="ttc" id="aclassBonus_html_a5b431fadd9abfe4bf59f9879f70a3410"><div class="ttname"><a href="classBonus.html#a5b431fadd9abfe4bf59f9879f70a3410">Bonus::CollideWith</a></div><div class="ttdeci">void CollideWith(GameObject *collisionObject) override</div><div class="ttdoc">Creates Visitor object and passes collisionObject parameter.</div><div class="ttdef"><b>Definition:</b> Bonus.cpp:19</div></div>
<div class="ttc" id="aclassCollisionVisitor_html"><div class="ttname"><a href="classCollisionVisitor.html">CollisionVisitor</a></div><div class="ttdoc">Abstract class of double dispatch visitor design patter.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:18</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
